Index: trunk/examples/extended/electromagnetic/TestEm6/src/PrimaryGeneratorAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm6/src/PrimaryGeneratorAction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm6/src/PrimaryGeneratorAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PrimaryGeneratorAction.cc,v 1.3 2006/06/29 16:57:14 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm6/src/PrimaryGeneratorMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm6/src/PrimaryGeneratorMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm6/src/PrimaryGeneratorMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PrimaryGeneratorMessenger.cc,v 1.5 2006/06/29 16:57:17 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm6/src/RunAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm6/src/RunAction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm6/src/RunAction.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: RunAction.cc,v 1.12 2006/06/29 16:57:20 gunter Exp $
-// GEANT4 tag $Name:  $
+// $Id: RunAction.cc,v 1.13 2008/09/18 16:42:07 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 // 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -59,7 +59,7 @@
    G4bool readOnly  = false;
    G4bool createNew = true;
-   G4String options = "--noErrors uncompress";
-   tree = tf->create("testem6.hbook","hbook",readOnly,createNew,options);
-   //tree = tf->create("testem6.root", "root",readOnly,createNew,options);
+   G4String options = "--noErrors export=root uncompress";
+   //tree = tf->create("testem6.hbook","hbook",readOnly,createNew,options);
+   tree = tf->create("testem6.root", "root",readOnly,createNew,options);
    //tree = tf->create("testem6.XML" ,"XML"  ,readOnly,createNew,options);
    delete tf;
Index: trunk/examples/extended/electromagnetic/TestEm6/src/SteppingAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm6/src/SteppingAction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm6/src/SteppingAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: SteppingAction.cc,v 1.9 2006/06/29 16:57:23 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm6/src/SteppingVerbose.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm6/src/SteppingVerbose.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm6/src/SteppingVerbose.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: SteppingVerbose.cc,v 1.5 2006/06/29 16:57:25 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/GNUmakefile
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/GNUmakefile	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/GNUmakefile	(revision 1230)
@@ -1,3 +1,3 @@
-# $Id: GNUmakefile,v 1.9 2007/06/22 12:44:42 maire Exp $
+# $Id: GNUmakefile,v 1.11 2008/09/21 16:03:10 vnivanch Exp $
 # --------------------------------------------------------------
 # GNUmakefile for examples module.  Gabriele Cosmo, 06/04/98.
@@ -17,15 +17,5 @@
 #### G4ANALYSIS_USE := true
 
-ifdef G4ANALYSIS_USE
-  CPPFLAGS += -DG4ANALYSIS_USE
-endif
-
 include $(G4INSTALL)/config/architecture.gmk
-
-ifdef G4ANALYSIS_USE
-  # for the aida-config command see the README file
-  CPPFLAGS += `aida-config --include`
-  LOADLIBS += `aida-config --lib`
-endif
 
 include $(G4INSTALL)/config/binmake.gmk
@@ -36,3 +26,3 @@
 
 histclean:
-	rm ${G4WORKDIR}/tmp/${G4SYSTEM}/${G4TARGET}/RunAction.o
+	rm ${G4WORKDIR}/tmp/${G4SYSTEM}/${G4TARGET}/Histo.o
Index: trunk/examples/extended/electromagnetic/TestEm7/TestEm7.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/TestEm7.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/TestEm7.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: TestEm7.cc,v 1.8 2007/06/22 12:44:42 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 // 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/include/DetectorConstruction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/DetectorConstruction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/DetectorConstruction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorConstruction.hh,v 1.2 2006/06/29 16:57:29 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/include/DetectorMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/DetectorMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/DetectorMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorMessenger.hh,v 1.3 2006/06/29 16:57:31 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/include/EventAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/EventAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/EventAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventAction.hh,v 1.2 2006/06/29 16:57:34 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/include/EventActionMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/EventActionMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/EventActionMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventActionMessenger.hh,v 1.3 2006/06/29 16:57:36 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/include/G4ScreenedNuclearRecoil.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/G4ScreenedNuclearRecoil.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/G4ScreenedNuclearRecoil.hh	(revision 1230)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4ScreenedNuclearRecoil.hh,v 1.3 2007/12/07 17:51:10 vnivanch Exp $
-// GEANT4 tag $Name:  $
+// G4ScreenedNuclearRecoil.hh,v 1.24 2008/05/01 19:58:59 marcus Exp
+// GEANT4 tag 
 //
 //
@@ -45,4 +45,5 @@
 //
 // First version, April 2004, Marcus H. Mendenhall, Vanderbilt University
+// May 1, 2008 -- Added code to allow process to have zero cross section above max energy, to coordinate with G4MSC.  -- mhm
 //
 // Class Description - End
@@ -54,4 +55,5 @@
 #include "globals.hh"
 #include "G4VDiscreteProcess.hh"
+#include "G4ParticleChange.hh"
 #include "c2_function.hh"
 
@@ -59,9 +61,13 @@
 #include <vector>
 
-class G4VParticleChange;
+class G4VNIELPartition;
+
+typedef c2_const_ptr<G4double> G4_c2_const_ptr;
+typedef c2_ptr<G4double> G4_c2_ptr;
+typedef c2_function<G4double> G4_c2_function;
 
 typedef struct G4ScreeningTables { 
 	G4double z1, z2, m1, m2, au, emin;
-	c2_function<G4double> *EMphiData; 
+	G4_c2_const_ptr EMphiData; 
 } G4ScreeningTables;
 
@@ -70,12 +76,11 @@
 {
 public:
-        G4ScreenedCoulombCrossSectionInfo() { }
-        ~G4ScreenedCoulombCrossSectionInfo() { }
-
-        const char *CVSHeaderVers() { return
-                "";
-        }
-
-        const char *CVSFileVers() { return ""; }
+	G4ScreenedCoulombCrossSectionInfo() { }
+	~G4ScreenedCoulombCrossSectionInfo() { }
+	
+	static const char* CVSHeaderVers() { return 
+		"G4ScreenedNuclearRecoil.hh,v 1.24 2008/05/01 19:58:59 marcus Exp GEANT4 tag ";
+	}
+	static const char* CVSFileVers();
 };
 
@@ -114,6 +119,6 @@
 	
 	// get the mean-free-path table for the indexed material 
-	c2_function<G4double> * operator [] (G4int materialIndex) { 
-			return MFPTables.find(materialIndex)!=MFPTables.end() ? MFPTables[materialIndex] : (c2_function<G4double> *)0;
+	const G4_c2_function * operator [] (G4int materialIndex) { 
+			return MFPTables.find(materialIndex)!=MFPTables.end() ? &(MFPTables[materialIndex].get()) : (G4_c2_function *)0;
 		}
 	
@@ -122,6 +127,6 @@
 	ParticleCache targetMap;
 	G4int verbosity;
-	std::map<G4int, c2_function<G4double> *> sigmaMap; // total cross section for each element
-	std::map<G4int, c2_function<G4double> *> MFPTables; // MFP for each material
+	std::map<G4int, G4_c2_const_ptr > sigmaMap; // total cross section for each element
+	std::map<G4int, G4_c2_const_ptr > MFPTables; // MFP for each material
 	
 private:
@@ -134,5 +139,7 @@
 	G4ScreenedCoulombCrossSection *crossSection;
 	G4double a1, a2, sinTheta, cosTheta, sinZeta, cosZeta, eRecoil;
-	G4ParticleDefinition *recoilIon;	} G4CoulombKinematicsInfo;
+	G4ParticleDefinition *recoilIon;	
+	const G4Material *targetMaterial;
+} G4CoulombKinematicsInfo;
 
 class G4ScreenedCollisionStage {
@@ -146,5 +153,5 @@
 
 public:
-	G4ScreenedCoulombClassicalKinematics() { }
+	G4ScreenedCoulombClassicalKinematics();
 	virtual void DoCollisionStep(class G4ScreenedNuclearRecoil *master,
 		const class G4Track& aTrack, const class G4Step& aStep);
@@ -153,5 +160,11 @@
 		const G4ScreeningTables *screen, 
 		G4double eps, G4double beta);
-	virtual ~G4ScreenedCoulombClassicalKinematics() {}
+	virtual ~G4ScreenedCoulombClassicalKinematics() { }
+protected:
+	// the c2_functions we need to do the work.
+	c2_const_plugin_function_p<G4double> &phifunc;
+	c2_linear_p<G4double> &xovereps;
+	G4_c2_ptr diff;
+	
 };
 
@@ -165,4 +178,9 @@
 };
 
+/**
+	\brief A process which handles screened Coulomb collisions between nuclei
+ 
+*/
+
 class G4ScreenedNuclearRecoil : public G4ScreenedCoulombCrossSectionInfo, public G4VDiscreteProcess
 {
@@ -171,54 +189,120 @@
 	friend class G4ScreenedCollisionStage;
 
+	/// \brief Construct the process and set some physics parameters for it.
+	/// \param processName the name to assign the process
+	/// \param ScreeningKey the name of a screening function to use.  
+	/// The default functions are "zbl" (recommended for soft scattering),
+	/// "lj" (recommended for backscattering) and "mol" (Moliere potential)
+	/// \param GenerateRecoils if frue, ions struck by primary are converted into new moving particles.
+	/// If false, energy is deposited, but no new moving ions are created.
+	/// \param RecoilCutoff energy below which no new moving particles will be created, 
+	/// even if \a GenerateRecoils is true.
+	/// Also, a moving primary particle will be stopped if its energy falls below this limit.
+	/// \param PhysicsCutoff the energy transfer to which screening tables are calucalted.  
+	/// There is no really
+	/// compelling reason to change it from the 10.0 eV default.  However, see the paper on running this
+	/// in thin targets for further discussion, and its interaction with SetMFPScaling()
 	G4ScreenedNuclearRecoil(const G4String& processName = "ScreenedElastic",
 			const G4String &ScreeningKey="zbl", G4bool GenerateRecoils=1, 
 			G4double RecoilCutoff=100.0*eV, G4double PhysicsCutoff=10.0*eV);
-	
+	/// \brief destructor
 	virtual ~G4ScreenedNuclearRecoil();
-	
+	/// \brief used internally by Geant4 machinery
 	virtual G4double GetMeanFreePath(const G4Track&, G4double, G4ForceCondition* );
-	
+	/// \brief used internally by Geant4 machinery
 	virtual G4VParticleChange* PostStepDoIt(const G4Track& aTrack, const G4Step& aStep);
-	
+	/// \brief test if a prticle of type \a aParticleType can use this process
+	/// \param aParticleType the particle to test
 	virtual G4bool IsApplicable(const G4ParticleDefinition& aParticleType);
-	
+	/// \brief Build physics tables in advance.  Not Implemented.
+	/// \param aParticleType the type of particle to build tables for 
 	virtual void BuildPhysicsTable(const G4ParticleDefinition&) { }
-	
+	/// \brief Export physics tables for persistency.  Not Implemented.
+	/// \param aParticleType the type of particle to build tables for 
 	virtual void DumpPhysicsTable(const G4ParticleDefinition& aParticleType);
-	
+	/// \brief deterine if the moving particle is within  the strong force range of the selected nucleus
+	/// \param A the nucleon number of the beam
+	/// \param A1 the nucleon number of the target
+	/// \param apsis the distance of closest approach
 	virtual G4bool CheckNuclearCollision(G4double A, G4double A1, G4double apsis); // return true if hard collision
 
 	virtual G4ScreenedCoulombCrossSection *GetNewCrossSectionHandler(void);
 	
-	G4double GetNIEL() const { return NIEL; } // Get non-ionizing energy loss for last step
-	
+	/// \brief Get non-ionizing energy loss for last step
+	G4double GetNIEL() const { return NIEL; } 
+	
+	/// \brief clear precomputed screening tables
 	void ResetTables(); // clear all data tables to allow changing energy cutoff, materials, etc.
-	
+
+	/// \brief set the upper energy beyond which this process has no cross section
+	///
+	/// This funciton is used to coordinate this process with G4MSC.  Typically, G4MSC should 
+	///  not be allowed to operate in a range which overlaps that of this process.  The criterion which is most reasonable
+	/// is that the transition should be somewhere in the modestly relativistic regime (500 MeV/u for example).
+	/// \param energy energy per nucleon for the cutoff
+	void SetMaxEnergyForScattering(G4double energy) { processMaxEnergy=energy; }
+	/// \brief find out what screening funciton we are using
 	std::string GetScreeningKey() const { return screeningKey; }
+	/// \brief enable or disable all energy deposition by this process
+	/// \param flag if true, enable deposition of energy (the default).  If false, disable deposition.
 	void AllowEnergyDeposition(G4bool flag) { registerDepositedEnergy=flag; }
+	/// \brief get flag indicating whether deposition is enabled
 	G4bool GetAllowEnergyDeposition() const { return registerDepositedEnergy; }
+	/// \brief enable or disable the generation of recoils.  
+	/// If recoils are disabled, the energy they would have received is just deposited.
+	/// \param flag if true, create recoil ions in cases in which the energy is above the recoilCutoff.  
+	/// If false, just deposit the energy.
 	void EnableRecoils(G4bool flag) { generateRecoils=flag; }
+	/// \brief find out if generation of recoils is enabled.
 	G4bool GetEnableRecoils() const { return generateRecoils; }
+	/// \brief set the mean free path scaling as specified
+	/// \param scale the factor by which the default MFP will be scaled.  
+	/// Set to less than 1 for very thin films, typically, to sample multiple scattering,
+	/// or to greater than 1 for quick simulaitons with a very long flight path.
 	void SetMFPScaling(G4double scale) { MFPScale=scale; }
+	/// \brief get the MFPScaling parameter
 	G4double GetMFPScaling() const { return MFPScale; }
+	/// \brief enable or disable whether this process will skip collisions 
+	/// which are close enough they need hadronic phsyics. Default is true (skip close collisions).
+	/// Disabling this results in excess nuclear stopping power.
+	/// \param flag true results in hard collisions being skipped.  false allows hard collisions.
 	void AvoidNuclearReactions(G4bool flag) { avoidReactions=flag; }
+	/// \brief get the flag indicating whether hadronic collisions are ignored.
 	G4bool GetAvoidNuclearReactions() const { return avoidReactions; }
+	/// \brief set the minimum energy (per nucleon) at which recoils can be generated, 
+	/// and the energy (per nucleon) below which all ions are stopped. 
+	/// \param energy energy per nucleon 
 	void SetRecoilCutoff(G4double energy) { recoilCutoff=energy; }
+	/// \brief get the recoil cutoff
 	G4double GetRecoilCutoff() const { return recoilCutoff; }
+	/// \brief set the energy to which screening tables are computed.  Typically, this is 10 eV or so, and not often changed.
+	/// \param energy the cutoff energy 
 	void SetPhysicsCutoff(G4double energy) { physicsCutoff=energy; ResetTables(); }
+	/// \brief get the physics cutoff energy.
 	G4double GetPhysicsCutoff() const { return physicsCutoff; }
-	class G4ParticleChange &GetParticleChange() { return aParticleChange; }
-	void AddToNIEL(G4double energy) { NIEL+=energy; }
+	/// \brief set the pointer to a class for paritioning energy into NIEL
+	/// \brief part the pointer to the class.
+	void SetNIELPartitionFunction(const G4VNIELPartition *part);
+	/// \brief set the cross section boost to provide faster computation of backscattering
+	/// \param fraction the fraction of particles to have their cross section boosted.
+	/// \param HardeningFactor the factor by which to boost the scattering cross section.
 	void SetCrossSectionHardening(G4double fraction, G4double HardeningFactor) {
 		hardeningFraction=fraction;
 		hardeningFactor=HardeningFactor;
 	}
+	/// \brief get the fraction of particles which will have boosted scattering
 	G4double GetHardeningFraction() const { return hardeningFraction; }
+	/// \brief get the boost factor in use.
 	G4double GetHardeningFactor() const { return hardeningFactor; }
+	/// \brief the the interaciton length used in the last scattering.
 	G4double GetCurrentInteractionLength() const { return currentInteractionLength; }
+	/// \brief set a function to compute screening tables, if the user needs non-standard behavior.
+	/// \param cs a class which constructs the screening tables.
 	void SetExternalCrossSectionHandler(G4ScreenedCoulombCrossSection *cs) { 
 		externalCrossSectionConstructor=cs; 
 	}
+	/// \brief get the verbosity.
 	G4int GetVerboseLevel() const { return verboseLevel; }
+
 	std::map<G4int, G4ScreenedCoulombCrossSection*> &GetCrossSectionHandlers() 
 		{ return crossSectionHandlers; }
@@ -228,12 +312,22 @@
 	void SetValidCollision(G4bool flag) { validCollision=flag; }
 	G4bool GetValidCollision() const { return validCollision; }
+
+	/// \brief get the pointer to our ParticleChange object.  for internal use, primarily.
+	class G4ParticleChange &GetParticleChange() { return static_cast<G4ParticleChange &>(*pParticleChange); }
+	/// \brief take the given energy, and use the material information to partition it into NIEL and ionizing energy.
+	void DepositEnergy(G4int z1, G4double a1, const G4Material *material, G4double energy);
 	
 protected:
-	G4double highEnergyLimit, lowEnergyLimit;
+	/// \brief the energy per nucleon above which the MFP is constant 
+	G4double highEnergyLimit;
+	/// \brief the energy per nucleon below which the MFP is zero
+	G4double lowEnergyLimit;
+	/// \brief the energy per nucleon beyond which the cross section is zero, to cross over to G4MSC
+	G4double processMaxEnergy;
 	G4String screeningKey;
 	G4bool generateRecoils, avoidReactions;
 	G4double recoilCutoff, physicsCutoff;
 	G4bool registerDepositedEnergy;
-	G4double NIEL;
+	G4double IonizingLoss, NIEL;
 	G4double MFPScale;
 	G4double hardeningFraction, hardeningFactor;
@@ -243,9 +337,8 @@
 	
 	std::map<G4int, G4ScreenedCoulombCrossSection*> crossSectionHandlers;		
-	std::map<G4int, c2_function<G4double>*> meanFreePathTables;
 	
 	G4bool validCollision;
 	G4CoulombKinematicsInfo kinematics;
-
+	const G4VNIELPartition *NIELPartitionFunction;
 };
 
@@ -268,5 +361,5 @@
 	std::vector<G4String> GetScreeningKeys() const;
 	
-	typedef c2_function<G4double> &(*ScreeningFunc)(G4int z1, G4int z2, size_t nPoints, G4double rMax, G4double *au);
+	typedef G4_c2_function &(*ScreeningFunc)(G4int z1, G4int z2, size_t nPoints, G4double rMax, G4double *au);
 	
 	void AddScreeningFunction(G4String name, ScreeningFunc fn) {
@@ -279,5 +372,8 @@
 };
 
-
+G4_c2_function &ZBLScreening(G4int z1, G4int z2, size_t npoints, G4double rMax, G4double *auval);
+G4_c2_function &MoliereScreening(G4int z1, G4int z2, size_t npoints, G4double rMax, G4double *auval);
+G4_c2_function &LJScreening(G4int z1, G4int z2, size_t npoints, G4double rMax, G4double *auval);
+G4_c2_function &LJZBLScreening(G4int z1, G4int z2, size_t npoints, G4double rMax, G4double *auval);
 
 #endif
Index: trunk/examples/extended/electromagnetic/TestEm7/include/PhysListEmLivermore.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/PhysListEmLivermore.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/PhysListEmLivermore.hh	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: PhysListEmLivermore.hh,v 1.1 2006/11/22 18:56:20 vnivanch Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/include/PhysListEmPenelope.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/PhysListEmPenelope.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/PhysListEmPenelope.hh	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: PhysListEmPenelope.hh,v 1.1 2006/11/22 18:56:21 vnivanch Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/include/PhysListEmStandard.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/PhysListEmStandard.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/PhysListEmStandard.hh	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: PhysListEmStandard.hh,v 1.3 2006/06/29 16:57:44 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/include/PhysListEmStandardNR.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/PhysListEmStandardNR.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/PhysListEmStandardNR.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PhysListEmStandardNR.hh,v 1.1 2008/01/14 12:11:38 vnivanch Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/include/PhysListEmStandardSS.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/PhysListEmStandardSS.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/PhysListEmStandardSS.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PhysListEmStandardSS.hh,v 1.1 2006/10/24 11:37:56 vnivanch Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/include/PhysicsList.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/PhysicsList.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/PhysicsList.hh	(revision 1230)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: PhysicsList.hh,v 1.6 2006/11/22 18:56:21 vnivanch Exp $
-// GEANT4 tag $Name:  $
+// $Id: PhysicsList.hh,v 1.8 2008/11/20 20:34:50 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -39,4 +39,5 @@
 
 #include "G4VModularPhysicsList.hh"
+#include "G4EmConfigurator.hh"
 #include "globals.hh"
 
@@ -50,4 +51,5 @@
 {
 public:
+
   PhysicsList();
   virtual ~PhysicsList();
@@ -67,4 +69,7 @@
 
 private:
+
+  G4EmConfigurator em_config; 
+
   G4double cutForGamma;
   G4double cutForElectron;
@@ -77,4 +82,5 @@
   G4String                             emName;
   G4VPhysicsConstructor*               emPhysicsList;
+  G4VPhysicsConstructor*               decPhysicsList;
   std::vector<G4VPhysicsConstructor*>  hadronPhys;
     
Index: trunk/examples/extended/electromagnetic/TestEm7/include/PhysicsListMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/PhysicsListMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/PhysicsListMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PhysicsListMessenger.hh,v 1.3 2006/06/29 16:57:52 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/include/PrimaryGeneratorAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/PrimaryGeneratorAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/PrimaryGeneratorAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PrimaryGeneratorAction.hh,v 1.3 2006/06/29 16:57:54 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/include/PrimaryGeneratorMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/PrimaryGeneratorMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/PrimaryGeneratorMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PrimaryGeneratorMessenger.hh,v 1.3 2006/06/29 16:57:56 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/include/RunAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/RunAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/RunAction.hh	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: RunAction.hh,v 1.12 2008/01/14 12:11:39 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: RunAction.hh,v 1.14 2008/08/22 18:30:27 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -40,10 +40,5 @@
 class PrimaryGeneratorAction;
 class G4Run;
-
-namespace AIDA {
- class IAnalysisFactory;
- class ITree;
- class IHistogram1D;
-} 
+class Histo;
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -52,5 +47,6 @@
 {
 public:
-  RunAction(DetectorConstruction*, PhysicsList*,PrimaryGeneratorAction*);
+  RunAction(DetectorConstruction*, PhysicsList*,
+	    PrimaryGeneratorAction*);
   virtual ~RunAction();
 
@@ -58,20 +54,19 @@
   void   EndOfRunAction(const G4Run*);
     
-  void FillTallyEdep(G4int n, G4double e) {tallyEdep[n] += e;};
+  void FillTallyEdep(G4int n, G4double e)  {tallyEdep[n] += e;};
   void FillEdep(G4double de, G4double eni) {edeptot += de; eniel += eni;};
        
   G4double GetBinLength() {return binLength;};
   G4double GetLength()    {return length;};
-  G4double GetOffsetX()   {return offsetX;} 
-  void     FillHisto(G4int id, G4double x, G4double weight = 1.0);
+  G4double GetOffsetX()   {return offsetX;}
+ 
+  void FillHisto(G4int id, G4double x, G4double weight = 1.0);
     
-  void AddProjRange (G4double x) {projRange += x; projRange2 += x*x;};
+  void AddProjRange (G4double x) 
+  {projRange += x; projRange2 += x*x; nRange++;};
   void AddPrimaryStep() {nPrimarySteps++;};
                    
 private:  
-  void bookHisto();
-  void cleanHisto();
     
-private:
   DetectorConstruction*   detector;
   PhysicsList*            physics;
@@ -84,8 +79,7 @@
   G4double                edeptot, eniel;
   G4int                   nPrimarySteps;
-           
-  AIDA::IAnalysisFactory* af;  
-  AIDA::ITree*            tree;
-  AIDA::IHistogram1D*     histo[1];        
+  G4int                   nRange;
+
+  Histo*                  histo;
 };
 
Index: trunk/examples/extended/electromagnetic/TestEm7/include/StepMax.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/StepMax.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/StepMax.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMax.hh,v 1.3 2006/06/29 16:58:01 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/include/StepMaxMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/StepMaxMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/StepMaxMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMaxMessenger.hh,v 1.2 2006/06/29 16:58:03 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/include/SteppingAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/SteppingAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/SteppingAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: SteppingAction.hh,v 1.2 2006/06/29 16:58:05 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
